initializeMatrices=function(Y,XX,lambda2,K, N, T)
{
CX				= vector("list",K)
CX_X			= vector("list",K)
CX_				= vector("list",K)
Zgamma			= vector("list",K)
Zgamma_old		= vector("list",K)
Z				= vector("list",K)
U				= vector("list",K)
S				= vector("list",K)

for (k in 1: K){

CX[[k]]	 	<- Reduce('+',lapply(seq_along(Y), 
function(i,k){.Call("R_txx", R_x=as.matrix(Y[[i]][[k]]),PACKAGE = "zoomJGL")$tXX}, k=k))
CX_[[k]] 	<- Reduce('+',lapply(seq_along(Y), 
function(i,k){.Call("R_txx", R_x=as.matrix(XX[[i]][[k]]),PACKAGE = "zoomJGL")$tXX}, k=k))
CX_X[[k]]	<- Reduce('+',lapply(seq_along(Y), 
function(i,k){.Call("R_txy", R_x=as.matrix(XX[[i]][[k]]),R_y=as.matrix(Y[[i]][[k]]),PACKAGE = "zoomJGL")$tXY}, k=k))


Zgamma[[k]] = qr.solve(CX_[[k]] + N * T * lambda2 * diag(ncol(CX_X[[k]])), CX_X[[k]])
CX[[k]]		= CX[[k]]/(N*T)
CX_[[k]]	= CX_[[k]]/(N*T)
CX_X[[k]]	= CX_X[[k]]/(N*T)


S[[k]] 		= CX[[k]]-.Call("R_txy", R_x=CX_X[[k]],R_y=Zgamma[[k]],PACKAGE = "zoomJGL")$tXY-
					  .Call("R_txy", R_x=Zgamma[[k]],R_y=CX_X[[k]],PACKAGE = "zoomJGL")$tXY+
					  .Call("R_txyz", R_x=Zgamma[[k]],R_y=CX_[[k]],R_C=Zgamma[[k]],PACKAGE = "zoomJGL")$tXYZ

				
Zgamma_old[[k]] <- Zgamma[[k]]	
Z[[k]]	 	 	<- matrix(0,dim(CX[[k]])[2],dim(CX[[k]])[2])
U[[k]]	 	 	<- matrix(0,dim(CX[[k]])[2],dim(CX[[k]])[2])

colnames(CX[[k]])=colnames(Y[[1]][[k]])
colnames(CX_[[k]])=colnames(Y[[1]][[k]])
colnames(CX_X[[k]])=colnames(XX[[1]][[k]])
colnames(Zgamma[[k]])=colnames(Y[[1]][[k]])
colnames(S[[k]])=colnames(Y[[1]][[k]])
colnames(Zgamma_old[[k]])=colnames(Y[[1]][[k]])
colnames(Z[[k]])=colnames(Y[[1]][[k]])
colnames(U[[k]])=colnames(Y[[1]][[k]])

rownames(CX[[k]])=colnames(Y[[1]][[k]])
rownames(CX_[[k]])=colnames(Y[[1]][[k]])
rownames(CX_X[[k]])=colnames(Y[[1]][[k]])
rownames(Zgamma[[k]])=colnames(Y[[1]][[k]])
rownames(S[[k]])=colnames(Y[[1]][[k]])
rownames(Zgamma_old[[k]])=colnames(Y[[1]][[k]])
rownames(Z[[k]])=colnames(Y[[1]][[k]])
rownames(U[[k]])=colnames(Y[[1]][[k]])
}

return(list(CX=CX,CX_=CX_,CX_X=CX_X,Zgamma=Zgamma,S=S,Zgamma_old=Zgamma_old,Z=Z,U=U))
}