
UpdateAllLevelk=function(Z,Zgamma,U,S,CX,CX_,CX_X,
lambda2,regularization1,regularization2,list.controls,N,T,iter,GammaGammadiff,mab)
{
edecomp		= .Call("R_eigen_decom2", R_A=(list.controls$rho*Z - 
				list.controls$rho*U - S),PACKAGE = "zoomJGL")
D2 			= (edecomp$values+sqrt(edecomp$values^2 + 4*list.controls$rho))*(1/(2*list.controls$rho))
X			= .Call("R_xytx", R_x=edecomp$vectors,R_y=diag(D2),PACKAGE = "zoomJGL")[[1]]
X_hat 		= list.controls$alpha*X + (1 - list.controls$alpha)*Z;
Z 			= soft(X_hat+U,regularization1)
U 			= U + X_hat - Z;

Zgamma_old 	= Zgamma
 



Zgamma 		= Gamma(CX=CX_, CXXZ=.Call("R_xy", R_x=CX_X,R_y=Z,PACKAGE = "zoomJGL")$XY,
				Z=Z, nlam=regularization2,lambda2,tol=list.controls$tol, 
				sbols=  1, warm=1,
				maxit= 1,Zgamma=Zgamma_old*(regularization2==lambda2))	

		 
colnames(Zgamma)= colnames(S)  
rownames(Zgamma)= rownames(S)
  	


	
S 		= CX-.Call("R_txy", R_x=CX_X,R_y=Zgamma,PACKAGE = "zoomJGL")$tXY-
			 .Call("R_txy", R_x=Zgamma,R_y=CX_X,PACKAGE = "zoomJGL")$tXY+
			 .Call("R_txyz", R_x=Zgamma,R_y=CX_,R_C=Zgamma,PACKAGE = "zoomJGL")$tXYZ


NegLogLik		= sum(diag(.Call("R_xy", R_x=S,R_y=X,PACKAGE = "zoomJGL")$XY))- sum(log(D2))

contrib			= NegLogLik + 
						sum(abs(.Call("R_elemwisexy", R_x=regularization1,R_y=Z,PACKAGE = "zoomJGL")$elemwiseXY))+
						sum(abs(.Call("R_elemwisexy", R_x=regularization2,R_y=Zgamma,PACKAGE = "zoomJGL")$elemwiseXY))
XZdiff			= norm(X - Z,"F")
GammaGammadiff	= norm(Zgamma - Zgamma_old,"F")
return(list(Z=Z,Zgamma=Zgamma,U=U,S=S,NegLogLik=NegLogLik,contrib=contrib,XZdiff=XZdiff,GammaGammadiff=GammaGammadiff))
}
