
Gamma <-
function(CX, CXXZ, Z, nlam,lambda2, tol=1e-5, sbols=1, maxit, quiet=0, warm=0, Zgamma=NULL)
{
p=dim(CX)[1]
q=dim(Z)[1]
tmp=matrix(0, nrow=p, ncol=q)
tol=as.double(tol*sbols)
mode(p) = "integer"
mode(q) = "integer"
mode(maxit) = "integer"
mode(quiet) = "integer"
mode(warm) = "integer"
if(warm==0) tmp=as.double(tmp) else tmp = as.double(Zgamma)
  ptm=proc.time()
dotCoutput=.C("Gamma",CX=as.double(CX), CXXZ=as.double(CXXZ), Z=as.double(Z),pin=p,
          qin=q, lamin=as.double(nlam),lambda2=as.double(lambda2), tol=tol,maxit=maxit, Bout=tmp)
B = matrix(dotCoutput$Bout, nrow=p, ncol=q)
 proc.time()-ptm

 
  
return(B)
}


