StARS.zoomJGL = function(Y,lambda1,lambda2,list.controls)
{


lambda=expand.grid(sort(lambda2,decreasing=TRUE),sort(lambda1,decreasing=TRUE))
lambda=cbind(lambda[,2],lambda[,1])
colnames(lambda)=c("Lambda1","Lambda2")



if(is.null(list.controls$stars.subsample.ratio))
	{
		if(nrow(Y[[1]][[1]])>144) stars.subsample.ratio = 10*
		sqrt(nrow(Y[[1]][[1]]))/nrow(Y[[1]][[1]])
		if(nrow(Y[[1]][[1]])<=144) stars.subsample.ratio = 0.8
	} 

est_Undirected=vector("list",length(Y[[1]]))	
est_Directed=vector("list",length(Y[[1]]))
cons_Undirected=vector("list",length(Y[[1]]))	
cons_Directed=vector("list",length(Y[[1]]))		
est_UndirectedLambda=vector("list",nrow(lambda))	
est_DirectedLambda=vector("list",nrow(lambda))	
cons_UndirectedLambda=vector("list",nrow(lambda))	
cons_DirectedLambda=vector("list",nrow(lambda))

for (j in 1:nrow(lambda))
{
dims=unlist(lapply(Y[[1]],ncol))
for (i in 1: length(dims))
{
est_Undirected[[i]]=matrix(0,dims[i],dims[i])	
est_Directed[[i]]=matrix(0,dims[i],dims[i])
cons_Undirected[[i]]=matrix(0,dims[i],dims[i])	
cons_Directed[[i]]=matrix(0,dims[i],dims[i])
}	


for(r in 1:list.controls$rep.num)	
	{ 
	print(paste("Lambda1-Lambda2 combination: ",j," out of ",nrow(lambda),sep=""))
	set.seed(2013+j+r)
					
	startpoint=sample(1:(nrow(Y[[1]][[1]])-floor(nrow(Y[[1]][[1]])*stars.subsample.ratio)),1)
	sam=c(startpoint:(startpoint+floor(nrow(Y[[1]][[1]])*stars.subsample.ratio)))
	
	
	Y2		= Y
	
	for (i in 1:length(Y)){
	for (k in 1:length(Y[[i]])){
	Y2[[i]][[k]]=Y[[i]][[k]][sam,]
	}}
				
	obj	= zoomJGL(Y2, lambda[j,1], lambda[j,2],list.controls=list.controls)
	
for (i in 1:length(obj$Constrain1)){obj$Constrain1[[i]][obj$Constrain1[[i]]!=lambda[j,1]]=0}
for (i in 1:length(obj$Constrain2)){obj$Constrain2[[i]][obj$Constrain2[[i]]!=lambda[j,2]]=0}
for (i in 1:length(obj$Constrain1)){obj$Constrain1[[i]][obj$Constrain1[[i]]==lambda[j,1]]=1}
for (i in 1:length(obj$Constrain2)){obj$Constrain2[[i]][obj$Constrain2[[i]]==lambda[j,2]]=1}
	
	est_Undirected= mapply("+",est_Undirected,obj$Undirected)
	est_Directed= mapply("+",est_Directed,obj$Directed)
	
	cons_Undirected= mapply("+",cons_Undirected,obj$Constrain1)
	cons_Directed= mapply("+",cons_Directed,obj$Constrain2)
	
	
	}
	est_UndirectedLambda[[j]]=est_Undirected
	est_DirectedLambda[[j]]=est_Directed
	cons_UndirectedLambda[[j]]=cons_Undirected
	cons_DirectedLambda[[j]]=cons_Directed
}




	variability_UndirectedLambda = matrix(0,nrow(lambda),length(Y[[1]]))
	variability_DirectedLambda = matrix(0,nrow(lambda),length(Y[[1]]))
	for(j in 1:nrow(lambda)){
	est_UndirectedLambda[[j]] = mapply("/",est_UndirectedLambda[[j]],list.controls$rep.num)
	cons_UndirectedLambda[[j]]= lapply(mapply("/",cons_UndirectedLambda[[j]],list.controls$rep.num),sum)
	variability_UndirectedLambda[j,] = 
	2*mapply("/",
	lapply(mapply("*",est_UndirectedLambda[[j]],
	mapply("+",mapply("*",est_UndirectedLambda[[j]],-1),1)
	),sum), cons_UndirectedLambda[[j]])

	est_DirectedLambda[[j]] = mapply("/",est_DirectedLambda[[j]],list.controls$rep.num)
	cons_DirectedLambda[[j]]= lapply(mapply("/",cons_DirectedLambda[[j]],list.controls$rep.num),sum)
	variability_DirectedLambda[j,] = 
	2*mapply("/",
	lapply(mapply("*",est_DirectedLambda[[j]],
	mapply("+",mapply("*",est_DirectedLambda[[j]],-1),1)
	),sum), cons_DirectedLambda[[j]])
	}

variability_DirectedLambda[is.nan(variability_DirectedLambda)]=0
variability_UndirectedLambda[is.nan(variability_UndirectedLambda)]=0

all=cbind(lambda,(rowSums(variability_UndirectedLambda)+
rowSums(variability_DirectedLambda)),
(rowSums(variability_UndirectedLambda)+
rowSums(variability_DirectedLambda)) <= list.controls$stars.thresh,(variability_UndirectedLambda+variability_DirectedLambda))
colnames(all)=c("Lambda1","Lambda2","StARS","IndicatorStARS",paste("StARS_Scale",1:length(Y[[1]]),sep=""))	

all2=as.matrix(all)
if(any(all[,4]==1)){all2 = matrix(all[which(all[, 4] == 1), ], ncol=ncol(all))}

opt.index			= 1
optimal_lambda_lik	= c(matrix(all2, ncol=ncol(all),byrow=F)[,1][opt.index],matrix(all2, ncol=ncol(all),byrow=F)[,2][opt.index])
candidate_levels=cbind(as.matrix(length(dims):1),as.matrix(rev(all2[opt.index,5:length(all2[opt.index,])])))
candidate_levels=candidate_levels[sort.list(candidate_levels[,2]),]
#opt.index.scale = max(which.max(candidate_levels[,2]>=list.controls$stars.thresh/length(dims))[1]-1,1)
opt.index.scale	= which.min(candidate_levels[,2])
optimal_scale 	= candidate_levels[opt.index.scale,1]		
return(list(optimal_lambda_lik=optimal_lambda_lik,optimal_scale=optimal_scale,all=all))
}	
