createAdjacency=function(obj)
{
	Undirected	= obj$Z
	Directed 	= obj$Z_AR

	for (k in 1:length(obj$Z)){
	Undirected[[k]][Undirected[[k]]!=0]	= 1
	diag(Undirected[[k]])				= 0
	Directed[[k]][Directed[[k]]!=0]		= 1
	}
	return(list(Directed=Directed,Undirected=Undirected))
	rm(list=ls())
}


createAR1=function(Y,N,K,T)
{	
	XX=Y
	for (i in 1: N){
	for (j in 1: K){
	XX[[i]][[j]]=Y[[i]][[j]][1:(T-1),]
	Y[[i]][[j]]=Y[[i]][[j]][2:T,]
	}}
	return(list(Y=Y,XX=XX))
}

createAR2=function(Y,N,K,T)
{	
	X1=X2=XX=Y
	for (i in 1: N){
	for (j in 1: K){
	X2[[i]][[j]]=Y[[i]][[j]][2:(T-1),]
	X1[[i]][[j]]=Y[[i]][[j]][1:(T-2),]
	Y[[i]][[j]]=Y[[i]][[j]][3:T,]
	XX[[i]][[j]] <- Matrix::cBind(X1[[i]][[j]], X2[[i]][[j]])
	}}
	return(list(Y=Y,XX=XX))
}

killSmall=function(obj,list.controls)
{
	for (k in 1:length(obj$Z)){
	rounddown1 		= abs(obj$Z[[k]])>list.controls$truncate; 
	diag(rounddown1)= 0
	rounddown2 		= abs(obj$Z_AR[[k]])>list.controls$truncate; 
	obj$Z[[k]]		<- obj$Z[[k]]*rounddown1
	obj$Z_AR[[k]]	<- obj$Z_AR[[k]]*rounddown2}
	return(obj)
}

soft	=
function(a,lam)
{ sign(a)*pmax(0, abs(a)-lam)}

add.alpha	= 
function(COLORS, ALPHA)
{
	if(missing(ALPHA)) stop("provide a value for alpha between 0 and 1")
	RGB <- col2rgb(COLORS, alpha=TRUE)
	RGB[4,] <- round(RGB[4,]*ALPHA)
	NEW.COLORS <- rgb(RGB[1,], RGB[2,], RGB[3,], RGB[4,], maxColorValue = 255)
	return(NEW.COLORS)
}

transf	=
function(x,y,xmin=-69,xmax=70,ymin=-110,ymax=78,xnmin=0,xnmax=597,ynmin=0,ynmax=740)
{
	yn<-(y-ymin)*(ynmax-ynmin)/(ymax-ymin)
	xn<-(x-xmin)*(xnmax-xnmin)/(xmax-xmin)
	cbind(xn,yn)
} 

rescale<-function(x,newrange) {
	if(nargs() > 1 && is.numeric(x) && is.numeric(newrange)) {
# if newrange has max first, reverse it
		if(newrange[1] > newrange[2]) {
			newmin<-newrange[2]
			newrange[2]<-newrange[1]
			newrange[1]<-newmin
		}
		xrange<-range(x)
		if(xrange[1] == xrange[2]) stop("can't rescale a constant vector!")
		mfac<-(newrange[2]-newrange[1])/(xrange[2]-xrange[1])
		invisible(newrange[1]+(x-xrange[1])*mfac)
	}
	else {
		cat("Usage: rescale(x,newrange)\n")
		cat("\twhere x is a numeric object and newrange is the min and max of the new range\n")
	}
}


RatesUndirected=
function (trueMatrix, estMatrix) 
{
    if (is.matrix(trueMatrix) != TRUE) {
        stop("Error: ", paste(sQuote("trueMatrix"), sep = ""), 
            " must be a matrix.")
    }
    if (is.matrix(estMatrix) != TRUE) {
        stop("Error: ", paste(sQuote("estMatrix"), sep = ""), 
            " must be a matrix.")
    }
    true <- abs(sign(trueMatrix))
    means <- abs(sign(estMatrix))
	diag(true)=0
	diag(means)=0
	
    TP <- length(intersect(which(true[upper.tri(true)] == 1), which(means[upper.tri(means)] == 1)))
    FP <- length(intersect(which(true[upper.tri(true)] == 0), which(means[upper.tri(means)] == 1)))
    FN <- length(intersect(which(true[upper.tri(true)] == 1), which(means[upper.tri(means)] == 0)))
    TN <- length(intersect(which(true[upper.tri(true)] == 0), which(means[upper.tri(means)] == 0)))
    return(list(TP = TP, FP = FP, FN = FN, TN = TN))
}

RatesDirected=
function (trueMatrix, estMatrix) 
{
    if (is.matrix(trueMatrix) != TRUE) {
        stop("Error: ", paste(sQuote("trueMatrix"), sep = ""), 
            " must be a matrix.")
    }
    if (is.matrix(estMatrix) != TRUE) {
        stop("Error: ", paste(sQuote("estMatrix"), sep = ""), 
            " must be a matrix.")
    }
    true <- abs(sign(trueMatrix))
    means <- abs(sign(estMatrix))
	
    TP <- length(intersect(which(true == 1), which(means == 1)))
    FP <- length(intersect(which(true == 0), which(means == 1)))
    FN <- length(intersect(which(true == 1), which(means == 0)))
    TN <- length(intersect(which(true == 0), which(means == 0)))
    return(list(TP = TP, FP = FP, FN = FN, TN = TN))
}





Conc2Adj=function(x){diag(x)=0;x[x!=0]=1;return(x)}
AR2Adj=function(x){x[x!=0]=1;return(x)}